#===============================================================================
# Copyright 2014-2017 Intel Corporation All Rights Reserved.
#
# The source code,  information  and material  ("Material") contained  herein is
# owned by Intel Corporation or its  suppliers or licensors,  and  title to such
# Material remains with Intel  Corporation or its  suppliers or  licensors.  The
# Material  contains  proprietary  information  of  Intel or  its suppliers  and
# licensors.  The Material is protected by  worldwide copyright  laws and treaty
# provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
# modified, published,  uploaded, posted, transmitted,  distributed or disclosed
# in any way without Intel's prior express written permission.  No license under
# any patent,  copyright or other  intellectual property rights  in the Material
# is granted to  or  conferred  upon  you,  either   expressly,  by implication,
# inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
# property rights must be express and approved by Intel in writing.
#
# Unless otherwise agreed by Intel in writing,  you may not remove or alter this
# notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
# suppliers or licensors in any way.
#===============================================================================

## <a name="DAAL-EXAMPLE-PY-SVD_DISTRIBUTED"></a>
## \example svd_dense_distr.py

from os import environ
from os.path import join as jp

import daal.algorithms.svd
from daal.algorithms.svd import (
    Distributed, outputOfStep2ForStep3, data,
    singularValues, rightSingularMatrix, outputOfStep1ForStep2, outputOfStep1ForStep3,
    inputOfStep3FromStep1, inputOfStep3FromStep2, inputOfStep2FromStep1,
    leftSingularMatrix
)
from daal import step1Local, step2Master, step3Local
from daal.data_management import FileDataSource, DataSourceIface
import inspect, sys, os.path
utils_folder = os.path.realpath(os.path.abspath(jp(os.path.split(inspect.getfile(inspect.currentframe()))[0], "..")))
if utils_folder not in sys.path:
    sys.path.insert(0, utils_folder)
from utils import printNumericTable

DAAL_PREFIX = jp('..', 'data')

# Input data set parameters
nBlocks = 4

datasetFileNames = [
    jp(DAAL_PREFIX, 'distributed', 'svd_1.csv'),
    jp(DAAL_PREFIX, 'distributed', 'svd_2.csv'),
    jp(DAAL_PREFIX, 'distributed', 'svd_3.csv'),
    jp(DAAL_PREFIX, 'distributed', 'svd_4.csv')
]

dataFromStep1ForStep2 = [0] * nBlocks
dataFromStep1ForStep3 = [0] * nBlocks
dataFromStep2ForStep3 = [0] * nBlocks
Sigma = None
V = None
Ui = [0] * nBlocks


def computestep1Local(block):
    global dataFromStep1ForStep2, dataFromStep1ForStep3

    # Initialize FileDataSource<CSVFeatureManager> to retrieve the input data from a .csv file
    dataSource = FileDataSource(
        datasetFileNames[block],
        DataSourceIface.doAllocateNumericTable,
        DataSourceIface.doDictionaryFromContext
    )

    # Retrieve the input data
    dataSource.loadDataBlock()

    # Create an algorithm to compute SVD on the local node
    algorithm = Distributed(step1Local)

    algorithm.input.set(data, dataSource.getNumericTable())

    # Compute SVD and get OnlinePartialResult class from daal.algorithms.svd
    pres = algorithm.compute()

    dataFromStep1ForStep2[block] = pres.get(outputOfStep1ForStep2)
    dataFromStep1ForStep3[block] = pres.get(outputOfStep1ForStep3)


def computeOnMasterNode():
    global Sigma, V, dataFromStep2ForStep3

    # Create an algorithm to compute SVD on the master node
    algorithm = Distributed(step2Master)

    for i in range(nBlocks):
        algorithm.input.add(inputOfStep2FromStep1, i, dataFromStep1ForStep2[i])

    # Compute SVD and get DistributedPartialResult class from daal.algorithms.svd
    pres = algorithm.compute()

    for i in range(nBlocks):
        dataFromStep2ForStep3[i] = pres.getCollection(outputOfStep2ForStep3, i)

    res = algorithm.finalizeCompute()

    Sigma = res.get(singularValues)
    V = res.get(rightSingularMatrix)


def finalizeComputestep1Local(block):
    global Ui

    # Create an algorithm to compute SVD on the master node
    algorithm = Distributed(step3Local)

    algorithm.input.set(inputOfStep3FromStep1, dataFromStep1ForStep3[block])
    algorithm.input.set(inputOfStep3FromStep2, dataFromStep2ForStep3[block])

    # Compute SVD
    algorithm.compute()
    res = algorithm.finalizeCompute()

    Ui[block] = res.get(leftSingularMatrix)

if __name__ == "__main__":

    for i in range(nBlocks):
        computestep1Local(i)

    computeOnMasterNode()

    for i in range(nBlocks):
        finalizeComputestep1Local(i)

    # Print the results
    printNumericTable(Sigma, "Singular values:")
    printNumericTable(V,     "Right orthogonal matrix V:")
    printNumericTable(Ui[0], "Part of left orthogonal matrix U from 1st node:", 10)
